module Slurpee
  class CSV
    attr_accessor :key_order, :data, :row_count

    # create
    def initialize(keys)
      @data = {}
      @key_order = {}
      @row_count = 0

      keys.each_with_index do |key, i|
        @key_order[i] = key
        @data[key] = []
      end
    end

    # O(c) ugh fix
    # read
    def row(index)
      row_str = ""

      @data.each do |j, w|
        row_str << "#{w[index]}, "
      end

      row_str
    end

    # O(1)
    # read
    def column(index)
      @data[index]
    end

    # O(k)
    # update
    def new_row!(params)
      @key_order.each do |k, v|
        @data[v] << (params[v].nil?? "" : params[v])
      end

      @row_count+=1
    end

    # O(cr) ugh super fix plz
    # show
    def rows
      rows = []

      (0..@row_count).each do |i|
        rows << row(i)
      end

      rows
    end
  end
end
